var search_data = {"index":{"searchIndex":["timecalc","dst","diff","op","sequence","types","units","value","%()","+()","-()","-@()","/()","<=>()","<=>()","==()","==()","_merge()","call()","call()","ceil()","coerce()","coerce_classes()","coerce_date()","coerce_zones()","compare()","compare()","compatible?()","convert()","convert()","direction()","div()","divmod()","dst?()","each()","exact()","factorize()","fix_day_diff()","fix_time_zone()","fix_value()","floor()","floor_week()","for()","for()","from()","from_now()","from_today()","inspect()","inspect()","inspect()","inspect()","inspect()","is?()","iterate()","matching_direction?()","merge()","merge_activesupport__timewithzone()","merge_date()","merge_datetime()","merge_time()","modulo()","month_div()","multiplier_for()","negative?()","new()","new()","new()","new()","new()","now()","plus_months()","plus_seconds()","positive?()","round()","select_units()","simple_div()","singular_div()","step()","step()","to()","to()","to_proc()","to_s()","today()","truncate()","try_unwrap()","unwrap()","wrap()","wrap()","wrap_now()","wrap_today()","year_div()","zone()"],"longSearchIndex":["timecalc","timecalc::dst","timecalc::diff","timecalc::op","timecalc::sequence","timecalc::types","timecalc::units","timecalc::value","timecalc::diff#%()","timecalc::value#+()","timecalc::value#-()","timecalc::diff#-@()","timecalc::diff#/()","timecalc::diff#<=>()","timecalc::value#<=>()","timecalc#==()","timecalc::sequence#==()","timecalc::types#_merge()","timecalc::op#call()","timecalc::units::call()","timecalc::value#ceil()","timecalc::diff#coerce()","timecalc::diff#coerce_classes()","timecalc::diff#coerce_date()","timecalc::diff#coerce_zones()","timecalc::dst#compare()","timecalc::types#compare()","timecalc::types#compatible?()","timecalc::types#convert()","timecalc::value#convert()","timecalc::sequence#direction()","timecalc::diff#div()","timecalc::diff#divmod()","timecalc::value#dst?()","timecalc::sequence#each()","timecalc::diff#exact()","timecalc::diff#factorize()","timecalc::dst#fix_day_diff()","timecalc::types#fix_time_zone()","timecalc::dst#fix_value()","timecalc::value#floor()","timecalc::value#floor_week()","timecalc::sequence#for()","timecalc::value#for()","timecalc::from()","timecalc::from_now()","timecalc::from_today()","timecalc#inspect()","timecalc::diff#inspect()","timecalc::op#inspect()","timecalc::sequence#inspect()","timecalc::value#inspect()","timecalc::dst#is?()","timecalc::value#iterate()","timecalc::sequence#matching_direction?()","timecalc::value#merge()","timecalc::types#merge_activesupport__timewithzone()","timecalc::types#merge_date()","timecalc::types#merge_datetime()","timecalc::types#merge_time()","timecalc::diff#modulo()","timecalc::diff#month_div()","timecalc::units::multiplier_for()","timecalc::diff#negative?()","timecalc::new()","timecalc::diff::new()","timecalc::op::new()","timecalc::sequence::new()","timecalc::value::new()","timecalc::now()","timecalc::value#plus_months()","timecalc::value#plus_seconds()","timecalc::diff#positive?()","timecalc::value#round()","timecalc::diff#select_units()","timecalc::diff#simple_div()","timecalc::diff#singular_div()","timecalc::sequence#step()","timecalc::value#step()","timecalc::sequence#to()","timecalc::value#to()","timecalc::op#to_proc()","timecalc::sequence#to_s()","timecalc::today()","timecalc::value#truncate()","timecalc::diff#try_unwrap()","timecalc::value#unwrap()","timecalc::wrap()","timecalc::value::wrap()","timecalc::wrap_now()","timecalc::wrap_today()","timecalc::diff#year_div()","timecalc::diff#zone()"],"info":[["TimeCalc","","TimeCalc.html","","<p>Module for time arithmetic.\n<p>Examples of usage:\n<p>“`ruby TimeCalc.(Time.now).+(1, :day) # =&gt; 2019-07-04 …\n"],["TimeCalc::DST","","TimeCalc/DST.html","","<p>@private\n"],["TimeCalc::Diff","","TimeCalc/Diff.html","","<p>Represents difference between two time-or-date values.\n<p>Typically created with just\n<p>“`ruby TimeCalc.(t1) …\n"],["TimeCalc::Op","","TimeCalc/Op.html","","<p>Abstraction over chain of time math operations that can be applied to a time or date.\n<p>@example\n\n<pre>op = TimeCalc.+(1, ...</pre>\n"],["TimeCalc::Sequence","","TimeCalc/Sequence.html","","<p>`Sequence` is a Enumerable, allowing to iterate from start point in time over defined step, till end …\n"],["TimeCalc::Types","","TimeCalc/Types.html","","<p>@private Tries to encapsulate all the differences between Time, Date, DateTime\n"],["TimeCalc::Units","","TimeCalc/Units.html","","<p>@private Unit-related constants and utilities for fetching their values\n"],["TimeCalc::Value","","TimeCalc/Value.html","","<p>Wrapper (one can say “monad”) around date/time value, allowing to perform several TimeCalc …\n"],["%","TimeCalc::Diff","TimeCalc/Diff.html#method-i-25","(span, unit = nil)",""],["+","TimeCalc::Value","TimeCalc/Value.html#method-i-2B","(span, unit)","<p>Add `&lt;span units&gt;` to wrapped value.\n<p>@param span [Integer] @param unit [Symbol] @return [Value] …\n"],["-","TimeCalc::Value","TimeCalc/Value.html#method-i-2D","(span_or_other, unit = nil)","<p>@overload -(span, unit)\n\n<pre>Subtracts `span units` from wrapped value.\n@param span [Integer]\n@param unit [Symbol] ...</pre>\n"],["-@","TimeCalc::Diff","TimeCalc/Diff.html#method-i-2D-40","()","<p>“Negates” the diff by swapping its operands. @return [Diff]\n"],["/","TimeCalc::Diff","TimeCalc/Diff.html#method-i-2F","(span, unit = nil)",""],["<=>","TimeCalc::Diff","TimeCalc/Diff.html#method-i-3C-3D-3E","(other)","<p>@return [-1, 0, 1]\n"],["<=>","TimeCalc::Value","TimeCalc/Value.html#method-i-3C-3D-3E","(other)","<p>@return [1, 0, -1]\n"],["==","TimeCalc","TimeCalc.html#method-i-3D-3D","(other)","<p>@return [true,false]\n"],["==","TimeCalc::Sequence","TimeCalc/Sequence.html#method-i-3D-3D","(other)","<p>@private\n"],["_merge","TimeCalc::Types","TimeCalc/Types.html#method-i-_merge","(value, attrs)",""],["call","TimeCalc::Op","TimeCalc/Op.html#method-i-call","(date_or_time)","<p>Performs the whole chain of operation on parameter, returning the result.\n<p>@param date_or_time [Date,  …\n"],["call","TimeCalc::Units","TimeCalc/Units.html#method-c-call","(unit)",""],["ceil","TimeCalc::Value","TimeCalc/Value.html#method-i-ceil","(unit)","<p>Ceils (rounds up) underlying date/time to nearest `unit`.\n<p>@example\n\n<pre>TimeCalc.from(Time.parse(&#39;2018-06-23 ...</pre>\n"],["coerce","TimeCalc::Diff","TimeCalc/Diff.html#method-i-coerce","(from, to)",""],["coerce_classes","TimeCalc::Diff","TimeCalc/Diff.html#method-i-coerce_classes","(from, to)",""],["coerce_date","TimeCalc::Diff","TimeCalc/Diff.html#method-i-coerce_date","(date, other)","<p>Will coerce Date to Time or DateTime, with the _zone of the latter_\n"],["coerce_zones","TimeCalc::Diff","TimeCalc/Diff.html#method-i-coerce_zones","(from, to)",""],["compare","TimeCalc::DST","TimeCalc/DST.html#method-i-compare","(v1, v2)",""],["compare","TimeCalc::Types","TimeCalc/Types.html#method-i-compare","(v1, v2)",""],["compatible?","TimeCalc::Types","TimeCalc/Types.html#method-i-compatible-3F","(v1, v2)",""],["convert","TimeCalc::Types","TimeCalc/Types.html#method-i-convert","(v, klass)",""],["convert","TimeCalc::Value","TimeCalc/Value.html#method-i-convert","(klass)","<p>@private\n"],["direction","TimeCalc::Sequence","TimeCalc/Sequence.html#method-i-direction","()",""],["div","TimeCalc::Diff","TimeCalc/Diff.html#method-i-div","(span, unit = nil)","<p>@example\n\n<pre class=\"ruby\"><span class=\"ruby-identifier\">t1</span> = <span class=\"ruby-constant\">Time</span>.<span class=\"ruby-identifier\">parse</span>(<span class=\"ruby-string\">&#39;2019-06-01 14:50&#39;</span>)\n<span class=\"ruby-identifier\">t2</span> = <span class=\"ruby-constant\">Time</span>.<span class=\"ruby-identifier\">parse</span>(<span class=\"ruby-string\">&#39;2019-06-15 12:10&#39;</span>)\n(<span class=\"ruby-constant\">TimeCalc</span>.(<span class=\"ruby-identifier\">t2</span>) <span class=\"ruby-operator\">-</span> <span class=\"ruby-identifier\">t1</span>).<span class=\"ruby-identifier\">div</span>(<span class=\"ruby-value\">:day</span>) <span class=\"ruby-operator\">...</span>\n</pre>\n"],["divmod","TimeCalc::Diff","TimeCalc/Diff.html#method-i-divmod","(span, unit = nil)","<p>Combination of {#div} and {#modulo} in one operation.\n<p>@overload divmod(span, unit)\n\n<pre>@param span [Integer] ...</pre>\n"],["dst?","TimeCalc::Value","TimeCalc/Value.html#method-i-dst-3F","()",""],["each","TimeCalc::Sequence","TimeCalc/Sequence.html#method-i-each","()","<p>@overload each\n\n<pre>@yield [Date/Time/DateTime] Next element in sequence\n@return [self]</pre>\n<p>@overload each\n"],["exact","TimeCalc::Diff","TimeCalc/Diff.html#method-i-exact","()","<p>@private\n"],["factorize","TimeCalc::Diff","TimeCalc/Diff.html#method-i-factorize","(zeroes: true, max: :year, min: :sec, weeks: true)","<p>“Factorizes” the distance between two points in time into units: years, months, weeks, days. …\n"],["fix_day_diff","TimeCalc::DST","TimeCalc/DST.html#method-i-fix_day_diff","(from, to, diff)",""],["fix_time_zone","TimeCalc::Types","TimeCalc/Types.html#method-i-fix_time_zone","(attrs, origin)",""],["fix_value","TimeCalc::DST","TimeCalc/DST.html#method-i-fix_value","(val, origin)",""],["floor","TimeCalc::Value","TimeCalc/Value.html#method-i-floor","(unit)",""],["floor_week","TimeCalc::Value","TimeCalc/Value.html#method-i-floor_week","()",""],["for","TimeCalc::Sequence","TimeCalc/Sequence.html#method-i-for","(span, unit)","<p>Produces sequence ending at `from.+(span, unit)`.\n<p>@example\n\n<pre>TimeCalc.(Time.parse(&#39;2019-06-01 14:50&#39;)).step(1, ...</pre>\n"],["for","TimeCalc::Value","TimeCalc/Value.html#method-i-for","(span, unit)","<p>Produces {Sequence} from this value to `this + &lt;span units&gt;`\n<p>@param span [Integer] @param unit [Symbol] …\n"],["from","TimeCalc","TimeCalc.html#method-c-from","(date_or_time)","<p>Returns {Value} wrapper, useful for performing several operations at once:\n<p>“`ruby TimeCalc.from(Time.parse …\n"],["from_now","TimeCalc","TimeCalc.html#method-c-from_now","()","<p>Shortcut for `TimeCalc.from(Time.now)` @return [Value]\n"],["from_today","TimeCalc","TimeCalc.html#method-c-from_today","()","<p>Shortcut for `TimeCalc.from(Date.today)` @return [Value]\n"],["inspect","TimeCalc","TimeCalc.html#method-i-inspect","()","<p>@private\n"],["inspect","TimeCalc::Diff","TimeCalc/Diff.html#method-i-inspect","()","<p>@private\n"],["inspect","TimeCalc::Op","TimeCalc/Op.html#method-i-inspect","()","<p>@private\n"],["inspect","TimeCalc::Sequence","TimeCalc/Sequence.html#method-i-inspect","()","<p>@private\n"],["inspect","TimeCalc::Value","TimeCalc/Value.html#method-i-inspect","()","<p>@private\n"],["is?","TimeCalc::DST","TimeCalc/DST.html#method-i-is-3F","(tm)","<p>it returns nil if dst? is not applicable to the value\n"],["iterate","TimeCalc::Value","TimeCalc/Value.html#method-i-iterate","(span, unit)","<p>Like {#+}, but allows conditional skipping of some periods. Increases value by `unit` at least `span` …\n"],["matching_direction?","TimeCalc::Sequence","TimeCalc/Sequence.html#method-i-matching_direction-3F","(val)",""],["merge","TimeCalc::Value","TimeCalc/Value.html#method-i-merge","(**attrs)","<p>Produces new value with some components of underlying time/date replaced.\n<p>@example\n\n<pre>TimeCalc.from(Date.parse(&#39;2018-06-01&#39;)).merge(year: ...</pre>\n"],["merge_activesupport__timewithzone","TimeCalc::Types","TimeCalc/Types.html#method-i-merge_activesupport__timewithzone","(value, **attrs)",""],["merge_date","TimeCalc::Types","TimeCalc/Types.html#method-i-merge_date","(value, **attrs)",""],["merge_datetime","TimeCalc::Types","TimeCalc/Types.html#method-i-merge_datetime","(value, **attrs)",""],["merge_time","TimeCalc::Types","TimeCalc/Types.html#method-i-merge_time","(value, **attrs)",""],["modulo","TimeCalc::Diff","TimeCalc/Diff.html#method-i-modulo","(span, unit = nil)","<p>Same as integer modulo: the “rest” of whole division of the distance between two time points …\n"],["month_div","TimeCalc::Diff","TimeCalc/Diff.html#method-i-month_div","()",""],["multiplier_for","TimeCalc::Units","TimeCalc/Units.html#method-c-multiplier_for","(klass, unit, precise: false)",""],["negative?","TimeCalc::Diff","TimeCalc/Diff.html#method-i-negative-3F","()","<p>@return [true, false]\n"],["new","TimeCalc","TimeCalc.html#method-c-new","(date_or_time)","<p>Creates a “temporary” wrapper, which would be unwrapped after first operation:\n<p>“`ruby TimeCalc.new(Time.now) …\n"],["new","TimeCalc::Diff","TimeCalc/Diff.html#method-c-new","(from, to)","<p>@note\n\n<pre>Typically you should prefer {TimeCalc#-} to create Diff.</pre>\n<p>@param from [Time,Date,DateTime] @param …\n"],["new","TimeCalc::Op","TimeCalc/Op.html#method-c-new","(chain = [])","<p>@note\n\n<pre>Prefer `TimeCalc.&lt;operation&gt;` (for example {TimeCalc#+}) to create operations.</pre>\n"],["new","TimeCalc::Sequence","TimeCalc/Sequence.html#method-c-new","(from:, to: nil, step: nil)","<p>@note\n\n<pre class=\"ruby\"><span class=\"ruby-constant\">Prefer</span> <span class=\"ruby-constant\">TimeCalc</span><span class=\"ruby-comment\">#to or TimeCalc#step for producing sequences.</span>\n</pre>\n<p>@param from [Time, Date, DateTime] @param …\n"],["new","TimeCalc::Value","TimeCalc/Value.html#method-c-new","(time_or_date)","<p>@note\n\n<pre>Prefer {TimeCalc.wrap} to create a Value.</pre>\n<p>@param time_or_date [Time, Date, DateTime]\n"],["now","TimeCalc","TimeCalc.html#method-c-now","()","<p>Shortcut for `TimeCalc.(Time.now)` @return [TimeCalc]\n"],["plus_months","TimeCalc::Value","TimeCalc/Value.html#method-i-plus_months","(span)",""],["plus_seconds","TimeCalc::Value","TimeCalc/Value.html#method-i-plus_seconds","(span, unit)",""],["positive?","TimeCalc::Diff","TimeCalc/Diff.html#method-i-positive-3F","()","<p>@return [true, false]\n"],["round","TimeCalc::Value","TimeCalc/Value.html#method-i-round","(unit)","<p>Rounds up or down underlying date/time to nearest `unit`.\n<p>@example\n\n<pre>TimeCalc.from(Time.parse(&#39;2018-06-23 ...</pre>\n"],["select_units","TimeCalc::Diff","TimeCalc/Diff.html#method-i-select_units","(max:, min:, weeks:)",""],["simple_div","TimeCalc::Diff","TimeCalc/Diff.html#method-i-simple_div","(t1, t2, unit)",""],["singular_div","TimeCalc::Diff","TimeCalc/Diff.html#method-i-singular_div","(unit)",""],["step","TimeCalc::Sequence","TimeCalc/Sequence.html#method-i-step","(span = nil, unit = nil)","<p>@overload step\n\n<pre>@return [(Integer, Symbol)] current step</pre>\n<p>@overload step(unit)\n"],["step","TimeCalc::Value","TimeCalc/Value.html#method-i-step","(span, unit = nil)","<p>Produces endless {Sequence} from this value, with step specified.\n<p>@overload step(unit)\n\n<pre>Shortcut for `step(1, ...</pre>\n"],["to","TimeCalc::Sequence","TimeCalc/Sequence.html#method-i-to","(date_or_time = nil)","<p>@overload to\n\n<pre>@return [Value] current sequence end, wrapped into {Value}</pre>\n<p>@overload to(date_or_time)\n"],["to","TimeCalc::Value","TimeCalc/Value.html#method-i-to","(date_or_time)","<p>Produces {Sequence} from this value to `date_or_time`\n<p>@param date_or_time [Date, Time, DateTime] @return …\n"],["to_proc","TimeCalc::Op","TimeCalc/Op.html#method-i-to_proc","()","<p>Allows to pass operation with `&amp;operation`.\n<p>@return [Proc]\n"],["to_s","TimeCalc::Sequence","TimeCalc/Sequence.html#method-i-to_s","()",""],["today","TimeCalc","TimeCalc.html#method-c-today","()","<p>Shortcut for `TimeCalc.(Date.today)` @return [TimeCalc]\n"],["truncate","TimeCalc::Value","TimeCalc/Value.html#method-i-truncate","(unit)","<p>Truncates all time components lower than `unit`. In other words, “floors” (rounds down) underlying …\n"],["try_unwrap","TimeCalc::Diff","TimeCalc/Diff.html#method-i-try_unwrap","(tm)",""],["unwrap","TimeCalc::Value","TimeCalc/Value.html#method-i-unwrap","()","<p>@return [Time, Date, DateTime] The value of the original type that was wrapped and processed\n"],["wrap","TimeCalc","TimeCalc.html#method-c-wrap","(date_or_time)",""],["wrap","TimeCalc::Value","TimeCalc/Value.html#method-c-wrap","(value)","<p>@private\n"],["wrap_now","TimeCalc","TimeCalc.html#method-c-wrap_now","()",""],["wrap_today","TimeCalc","TimeCalc.html#method-c-wrap_today","()",""],["year_div","TimeCalc::Diff","TimeCalc/Diff.html#method-i-year_div","()",""],["zone","TimeCalc::Diff","TimeCalc/Diff.html#method-i-zone","(tm)",""]]}}